﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private Center, Scale As Double
	Private tHght As Double 
	Private Washer As JavaObject
	Private Nut As JavaObject
	Private pnLed As JavaObject 
	Private ClrT As Short
	Private SList(2) As List
	Private Stp0(3) As JavaObject 
	Private Stp1(3) As JavaObject 
	Private ledOn As Boolean = True	
	Public MouseClickEnabled As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
'ClrType: 0=Red 1=Green 2=Yellow 3=Blue
Public Sub Initialize(Hght As Double, ClrType As Short)
	ClrT = Max(Min(ClrType,3),0)
	tHght=Hght
	pnMain.Initialize("pnMain")
	pnMain.PrefHeight = tHght
	pnMain.PrefWidth = tHght
	SList(0).Initialize
	SList(1).Initialize 
	makePBt
End Sub

Public Sub Show(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
End Sub

Private Sub makePBt
	Scale = 60/tHght
	Dim Radius As Double
	Radius = tHght/2
	Center = tHght/2

	Washer.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	Dim strkWdt As Double = 0
	Washer.RunMethod("setStrokeWidth",Array (strkWdt))	
	
	Dim LinearGradient As JavaObject 
	Dim Stp0(3) As JavaObject
	Stp0(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(0, 0, 0)))
	Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.5, fx.Colors.RGB(255, 255, 255)))
	Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(0, 0, 0)))
	SList(0).Clear 
	SList(0).Add(Stp0(0))
	SList(0).Add(Stp0(1))
	SList(0).Add(Stp0(2))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(0.2322, 0.1327, 0.9905, 1.0, False,JO.RunMethod("valueOf",Array As Object ("REPEAT")),SList(0)))
	Washer.RunMethod("setFill", Array(LinearGradient))
	Dim NewPt(12) As Double
	Dim nPt As PointApi
	Dim CountPt As Short = -1
	Radius = 30/Scale
	Dim Angle As Double
	Dim ini As Short = Rnd(0,60)
	For i = ini To 359 Step 60
		Angle = i'*60
		nPt= new_pt(Angle,Radius,Center,Center)
		CountPt=CountPt + 1
		NewPt(CountPt) = nPt.X
		CountPt=CountPt + 1
		NewPt(CountPt) = nPt.Y
	Next
	Nut.InitializeNewInstance("javafx.scene.shape.Polygon",Array(NewPt))
	Dim LinearGradient As JavaObject 
	Stp0(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(255, 255, 255)))
	Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.5, fx.Colors.RGB(105, 105, 105)))
	Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(255, 255, 255)))
	SList(0).Clear 
	SList(0).Add(Stp0(0))
	SList(0).Add(Stp0(1))
	SList(0).Add(Stp0(2))
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	LinearGradient.InitializeNewInstance("javafx.scene.paint.LinearGradient", Array(0.23222, 0.1327, 0.9905, 1.0, True,JO.RunMethod("valueOf",Array As Object ("REPEAT")),SList(0)))
	Nut.RunMethod("setFill", Array(LinearGradient))
	Nut.RunMethod("setStrokeWidth",Array (1/Scale))	
	Nut.RunMethod("setStroke", Array(fx.Colors.darkGray))
	Radius = 20/Scale
	pnLed.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	pnLed.RunMethod("setStrokeWidth",Array (5/Scale))	
	Dim RadialGradient As JavaObject 
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	Stp0(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(105, 105, 105)))
	Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.5, fx.Colors.RGB(255, 255, 255)))
	Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(105, 105, 105)))
	SList(0).Clear 
	SList(0).Add(Stp0(0))
	SList(0).Add(Stp0(1))
	SList(0).Add(Stp0(2))
	RadialGradient.InitializeNewInstance("javafx.scene.paint.RadialGradient", Array(0.0, -0.4137931, 0.687845, 0.4810426,0.867816091, True,JO.RunMethod("valueOf",Array As Object ("REFLECT")),SList(0)))
	pnLed.RunMethod("setStroke", Array(RadialGradient))	
	setColor
	TurnOn(False)
	pnMain.AddNode(Nut,-1, -1, -1, -1)
	pnMain.AddNode(pnLed,-1, -1, -1, -1)
	
End Sub
Private Sub setColor
	Select Case ClrT
		Case 0 'Red
			Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(87, 12, 12)))
			Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(60, 5, 5)))

			Stp1(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(144, 5, 5)))
			Stp1(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(201, 7, 7)))
		Case 1	'Green
			Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(7, 44, 12)))
			Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(0, 16, 2)))

			Stp1(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(5, 168, 51)))
			Stp1(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(0, 255, 65)))
		Case 2	'yellow
			Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(114, 114, 1)))
			Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(81, 81, 3)))

			Stp1(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(174, 174, 9)))
			Stp1(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(224, 224, 0)))
		Case 3 	'Blue
			Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(7, 25, 67)))
			Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(4, 8, 33)))

			Stp1(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(2, 40, 164)))
			Stp1(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(0, 64, 255)))
	End Select
	Stp0(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(174, 169, 169)))
	Stp1(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(218, 212, 212)))
	SList(0).Clear
	SList(1).Clear
	For i = 0 To 2
		SList(0).Add(Stp0(i))
		SList(1).Add(Stp1(i))
	Next
End Sub

Public Sub TurnOn(lOn As Boolean)
	If lOn = ledOn Then Return
	ledOn = lOn
	Dim RadialGradient As JavaObject 
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	If ledOn Then
		RadialGradient.InitializeNewInstance("javafx.scene.paint.RadialGradient", Array(0.0, 0.0, 0.25, 0.335,0.51, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList(1)))
	Else
		RadialGradient.InitializeNewInstance("javafx.scene.paint.RadialGradient", Array(0.0, 0.0, 0.25, 0.335,0.51, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList(0)))
	End If
	pnLed.RunMethod("setFill", Array(RadialGradient))
End Sub

Private Sub pnMain_MouseClicked (EventData As MouseEvent)
	If Not(MouseClickEnabled) Then Return
	TurnOn(Not(gOn))
End Sub

Public Sub gOn As Boolean
	Return ledOn
End Sub

Private Sub new_pt(nAngle As Double, r As Double, CX  As Double, CY As Double ) As PointApi 
        Dim AngleRad As Double
		Dim pt As PointApi 
		nAngle = 90 + nAngle
        If nAngle > 360 Then nAngle = nAngle - 360
        AngleRad = nAngle * cPI / 180 'convert to rad
        If AngleRad < 0 Then AngleRad = 6.283 + AngleRad
        pt.x = CX + (r) * Cos(AngleRad)
        pt.Y  = CY - (r) * Sin(AngleRad)
        Return pt
End Sub