﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private pnMain As Pane
	Private Center, Scale As Double
	Private tHght, tWdth As Double 	
	Private pnLed As JavaObject 
	Private ClrT, Mdl As Short
	Private SList(2) As List
	Private Stp0(3) As JavaObject 
	Private Stp1(3) As JavaObject 
	Private ledOn As Boolean = True
	Private Enabled As Boolean = True
	Private Border As Short
	Public MouseClickEnabled As Boolean
	
End Sub

	'ClrType: 
		'0 = Red 
		'1 = Green 
		'2 = Yellow 
		'3 = Blue
	'
	'Model: 
	'0 = Circle 
	'1 = Rectangle
	'
	'Bd: Border Size
Public Sub Initialize(Hght As Double, ClrType As Short, Model As Short, Bd As Short)
	Border = Max(Min(Bd, 5), 0)
	Mdl = Max(Min(Model, 1), 0)
	ClrT = Max(Min(ClrType, 3), 0)
	tHght=Hght
	If Mdl = 0 Then 
		tWdth = tHght
	Else
		tWdth = tHght*1.5
	End If
	pnMain.Initialize("pnMain")
	pnMain.PrefHeight = tHght
	pnMain.PrefWidth = tWdth
	SList(0).Initialize
	SList(1).Initialize 
	makeLed
End Sub

Public Sub Show(frm As Form, lft As Int, Tp As Int)
	frm.RootPane.AddNode(pnMain,lft , Tp, -1, -1)
End Sub

Private Sub makeLed
	Scale = 20/tHght
	Dim Radius As Double
	If Mdl = 0 Then
		Radius = tHght/2
		Center = tHght/2
		pnLed.InitializeNewInstance("javafx.scene.shape.Circle", Array (Center, Center, Radius))	
	Else
		pnLed.InitializeNewInstance("javafx.scene.shape.Rectangle", Array (tWdth, tHght))	
	End If
	Dim strkWdt As Double = Border/Scale 
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeType")
	pnLed.RunMethod("setStrokeType",Array As Object(JO.RunMethod("valueOf",Array("INSIDE"))))

	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.shape.StrokeLineJoin")
	pnLed.RunMethod("setStrokeLineJoin",Array As Object(JO.RunMethod("valueOf",Array("BEVEL"))))
	pnLed.RunMethod("setStrokeWidth",Array (strkWdt))
	Dim RadialGradient As JavaObject 
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	Stp0(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(97, 96, 96)))
	Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(97, 97, 97)))
	Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(213, 213, 213)))
	For i = 0 To 2
		SList(0).Add(Stp0(i))
	Next	
	RadialGradient.InitializeNewInstance("javafx.scene.paint.RadialGradient", Array(0.0, 0.0, 0.25, 0.335,0.51, True,JO.RunMethod("valueOf",Array As Object ("REFLECT")),SList(0)))
	pnLed.RunMethod("setStroke", Array(RadialGradient))
	setColor
	TurnOn(False)
	pnMain.AddNode(pnLed,-1, -1, -1, -1)
End Sub

Private Sub setColor
	Dim swp0, swp1 As Short
	Dim rg0, rg1 As Double
	swp0 = 1: swp1 = 2
	rg0 = 0.33: rg1 = 1.0
	If Mdl = 1 Then
		swp0 = 2: swp1 = 1
		rg1 = 0.33: rg0 = 1.0
	End If
	Select Case ClrT
		Case 0 'Red
			Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(87, 12, 12)))
			Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(70, 15, 15)))
			
			Stp1(swp0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(rg0, fx.Colors.RGB(144, 5, 5)))
			Stp1(swp1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(rg1, fx.Colors.RGB(201, 7, 7)))
		Case 1	'Green
			Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(7, 44, 12)))
			Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(0, 16, 2)))
			
			Stp1(swp0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(rg0, fx.Colors.RGB(5, 168, 51)))
			Stp1(swp1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(rg1, fx.Colors.RGB(0, 255, 65)))
		Case 2	'yellow
			Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(114, 114, 1)))
			Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(81, 81, 3)))
			
			Stp1(swp0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(rg0, fx.Colors.RGB(174, 174, 9)))
			Stp1(swp1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(rg1, fx.Colors.RGB(224, 224, 0)))
		
		Case 3 	'Blue
			Stp0(1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.33, fx.Colors.RGB(7, 25, 67)))
			Stp0(2).InitializeNewInstance ("javafx.scene.paint.Stop",Array(1.0, fx.Colors.RGB(4, 8, 33)))
			
			Stp1(swp0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(rg0, fx.Colors.RGB(2, 40, 164)))
			Stp1(swp1).InitializeNewInstance ("javafx.scene.paint.Stop",Array(rg1, fx.Colors.RGB(0, 64, 255)))
	End Select
	Stp0(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(174, 169, 169)))
	Stp1(0).InitializeNewInstance ("javafx.scene.paint.Stop",Array(0.0, fx.Colors.RGB(218, 212, 212)))
	SList(0).Clear
	SList(1).Clear
	For i = 0 To 2
		SList(0).Add(Stp0(i))
		SList(1).Add(Stp1(i))
	Next
End Sub

Public Sub isEnabled(en As Boolean)
	If en = Enabled Then Return
	Enabled = en
	If Enabled Then
		pnMain.Alpha = 1.0
	Else
		TurnOn(False)
		pnMain.Alpha = 0.5
	End If
End Sub

Public Sub TurnOn(lOn As Boolean)
	If lOn = ledOn Then Return
	If Not(Enabled) Then Return
	ledOn = lOn
	Dim RadialGradient As JavaObject 
	Dim JO As JavaObject
	JO.InitializeStatic("javafx.scene.paint.CycleMethod")	
	If ledOn Then
		RadialGradient.InitializeNewInstance("javafx.scene.paint.RadialGradient", Array(0.0, 0.0, 0.25, 0.335,0.51, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList(1)))
	Else
		RadialGradient.InitializeNewInstance("javafx.scene.paint.RadialGradient", Array(0.0, 0.0, 0.25, 0.335,0.51, True,JO.RunMethod("valueOf",Array As Object ("NO_CYCLE")),SList(0)))
	End If
	pnLed.RunMethod("setFill", Array(RadialGradient))
End Sub

Private Sub pnMain_MouseClicked (EventData As MouseEvent)
	If Not(MouseClickEnabled) Then Return
	TurnOn(Not(Status))
End Sub

Public Sub Status As Boolean
	Return ledOn
End Sub